Scriptname INYAGetArmor extends ReferenceAlias

GlobalVariable Property INYAIndoorOnlyMode  Auto  
GlobalVariable Property INYAScaleMode  Auto  
GlobalVariable Property INYAWeightMode  Auto  
GlobalVariable Property INYADebugMode  Auto  
GlobalVariable Property INYASlotMask  Auto  
GlobalVariable Property INYASlotMaskb auto
GlobalVariable Property INYARandomWeight auto
GlobalVariable Property INYADeadEquip auto
GlobalVariable Property INYAWeightRange auto
GlobalVariable Property INYAScaleRange auto
GlobalVariable Property INYASexMode  Auto  
GlobalVariable Property INYAWeaponMode  Auto  
Faction Property CreatureFaction auto
Faction Property DaedraFaction auto
Faction Property DraugrFaction auto
Faction Property PreyFaction auto
Faction Property VampireFaction auto

bool eqflag = false
ObjectReference ContainerWork = none

Event OnItemAdded(Form akBaseItem, Int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer) 
	bool NoneFlag = false
	bool exeflag = true
	if (INYAIndoorOnlyMode.GetValue() == 1 && akSourceContainer && !akSourceContainer.IsInInterior())
		NoneFlag = true
	endif
	Actor act = akSourceContainer as Actor
	Actor actPC = Game.GetPlayer()
	if (act.IsInFaction(CreatureFaction) || act.IsInFaction(DaedraFaction) || act.IsInFaction(PreyFaction))
		exeFlag = false
	endif
	if (act.IsInFaction(VampireFaction))
		exeFlag = true
	endif
	if (act.IsInFaction(DraugrFaction) && act.GetLeveledActorBase().GetSex() == 1)
		;for Beautiful Draugr
		exeFlag = true
	endif
	int slotsChecked = GetGlobalMask()
	if (act && act.IsDead() && exeFlag == true)
		Armor amr = akBaseItem as Armor
		if (amr)
			if (!NoneFlag)
				int slotmask = amr.GetSlotMask()
				if (Math.LogicalAnd(slotsChecked, slotmask) != 0x00)
					Actor selfact = self.GetActorRef()
					ActorBase selfbase = selfact.GetActorBase()
					ActorBase srcbase = act.GetLeveledActorBase()
					float  srcweight = srcbase.GetWeight()

					if (INYARandomWeight.GetValue() == 1)
						float newWeight
						int baseWeight = (srcweight * 10) as int
						int ckwt = baseWeight % 10

						if (ckwt == 0)
							newWeight = Utility.RandomInt(0,100) as float
							newWeight += 0.1
							srcbase.SetWeight(newWeight)
							srcweight = newWeight
							;self.log("newWeight="+newWeight)
						endif

					endif

					float weightrange = INYAWeightRange.GetValue()
					float selfweight = selfbase.GetWeight()


					float scalerange = INYAScaleRange.GetValue()
					float selfheight = selfbase.GetHeight() * self.GetRef().GetScale()
					float srcheight = srcbase.GetHeight() * akSourceContainer.GetScale()

					;self.log("PCWeight : " + selfweight as int + " and int:" + srcbase.GetWeight() as int + " and float:" + srcbase.GetWeight())

					if (INYASexMode.GetValue() == 1 && selfbase.GetSex() != srcbase.GetSex())
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Gender")
					Elseif (INYAWeightMode.GetValue() == 1 && math.abs(selfweight - srcweight) > weightrange )
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Weight : " + selfweight as int + " and " + srcbase.GetWeight() as int)
					elseif (INYAScaleMode.GetValue() == 1 && math.abs(selfheight - srcheight) > scalerange )
						;self.log("player height:"+selfbase.GetHeight()+" scale:"+self.GetRef().GetScale())
						;self.log("target height:"+srcbase.GetHeight()+" scale:"+akSourceContainer.GetScale())
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Height : " + selfheight + " and " + srcheight)
					endif
				endif
			endif
		endif
		if (INYAWeaponMode.Getvalue() == 1)
			Weapon wep = akBaseItem as Weapon
			if (wep)
				if (!NoneFlag)
					Actor selfact = self.GetActorRef()
					ActorBase selfbase = selfact.GetActorBase()
					ActorBase srcbase = act.GetLeveledActorBase()
					float  srcweight = srcbase.GetWeight()

					if (INYARandomWeight.GetValue() == 1)
						float newWeight
						int baseWeight = (srcweight * 10) as int
						int ckwt = baseWeight % 10

						if (ckwt == 0)
							newWeight = Utility.RandomInt(0,100) as float
							newWeight += 0.1
							srcbase.SetWeight(newWeight)
							srcweight = newWeight
							;self.log("newWeight="+newWeight)
						endif

					endif

					float weightrange = INYAWeightRange.GetValue()
					float selfweight = selfbase.GetWeight()


					float scalerange = INYAScaleRange.GetValue()
					float selfheight = selfbase.GetHeight() * self.GetRef().GetScale()
					float srcheight = srcbase.GetHeight() * akSourceContainer.GetScale()

					;self.log("PCWeight : " + selfweight as int + " and int:" + srcbase.GetWeight() as int + " and float:" + srcbase.GetWeight())

					if (INYASexMode.GetValue() == 1 && selfbase.GetSex() != srcbase.GetSex())
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Gender")
					Elseif (INYAWeightMode.GetValue() == 1 && math.abs(selfweight - srcweight) > weightrange )
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Weight : " + selfweight as int + " and " + srcbase.GetWeight() as int)
					elseif (INYAScaleMode.GetValue() == 1 && math.abs(selfheight - srcheight) > scalerange )
						;self.log("player height:"+selfbase.GetHeight()+" scale:"+self.GetRef().GetScale())
						;self.log("target height:"+srcbase.GetHeight()+" scale:"+akSourceContainer.GetScale())
						self.returnitem(selfact, akBaseItem, akSourceContainer)
						self.log("It's not fit for you : Height : " + selfheight + " and " + srcheight)
					endif
				endif
			endif
		endif
	endif
EndEvent

;Event OnCellLoad()
;	if (INYARandomWeight.GetValue() == 1)
;		Cell currentCell = Game.GetPlayer().GetParentCell()
;		Int refs = currentCell.getNumRefs(43)
;		float weight
;		float newwt
;		Actor obj
;		while refs
;			refs -= 1
;			obj = (currentCell.getNthRef(refs, 43) as Actor)
;			if (!obj.GetLeveledActorBase().IsUnique() && !obj.IsInFaction(CreatureFaction) && !obj.IsInFaction(DaedraFaction) && !obj.IsInFaction(PreyFaction))
;				weight = obj.GetLeveledActorBase().GetWeight()
;				newwt = Utility.RandomInt(0,100) as float
;				obj.GetLeveledActorBase().SetWeight(newwt)
;			endif
;			if (obj.IsInFaction(DraugrFaction) && obj.GetLeveledActorBase().GetSex() == 1)
;				;for Beautiful Draugr
;				weight = obj.GetLeveledActorBase().GetWeight()
;				newwt = Utility.RandomInt(0,100) as float
;				obj.GetLeveledActorBase().SetWeight(newwt)
;			endif
;		EndWhile
;	endif
;EndEvent

event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	if (INYADeadEquip.GetValue() == 1 && eqflag == true)
		if (ContainerWork as Actor).isdead()
			int ItemType = akItemReference.GetBaseObject().GetType()
			if (ItemType == 26 || ItemType == 42 || ItemType == 41)
				(ContainerWork as actor).EquipItem(akItemReference.GetBaseObject(), True)
				(ContainerWork as actor).QueueNiNodeUpdate()
			EndIf
		endif
		eqflag = false
		ContainerWork = none
	endif
EndEvent

Function returnItem(Actor selfact, Form akBaseItem, ObjectReference akSourceContainer)
	eqflag = true
	ContainerWork = akSourceContainer
	ObjectReference akItemRef = selfact.DropObject(akBaseItem) as ObjectReference
	selfact.AddItem(akItemRef, 1, true)
	selfact.RemoveItem(akItemRef, 1, true, akSourceContainer)
	akItemRef.delete()
	akItemRef = none
EndFunction

Function log(String msg)
	float debugmode = INYADebugMode.GetValue()
	if (debugmode == 0)
		; nope
	elseif (debugmode == 1)
		debug.notification("[INYA] " +msg)
	elseif (debugmode == 2)
		debug.trace("[INYA] " + msg)
	endif
EndFunction

Int Function GetGlobalMask()
	Int CurrentArmorSlotsMaskB
	Int CurrentArmorSlotsMaskA
	CurrentArmorSlotsMaskB = Math.LeftShift(INYASlotMaskb.GetValue() As Int, 24)
	CurrentArmorSlotsMaskA = INYASlotMask.GetValue() As Int
	return Math.LogicalOr(CurrentArmorSlotsMaskA, CurrentArmorSlotsMaskB)
EndFunction

